#ifndef _GLOBAL_H_
#define _GLOBAL_H_

#ifdef __cplusplus
extern "C" {
#endif

# define MO5_RENDER_NORMAL     0
# define MO5_RENDER_X125       1
# define MO5_RENDER_FIT        2
# define MO5_RENDER_MAX        3
# define MO5_LAST_RENDER       3

# define MO5_WIDTH  336
# define MO5_HEIGHT 216

# define SNAP_WIDTH   (MO5_WIDTH*10/25)
# define SNAP_HEIGHT  (MO5_HEIGHT*10/25)

# define MAX_PATH   256
# define MO5_MAX_SAVE_STATE 5

#include <psptypes.h>

#define TRUE 1
#define FALSE 0

typedef unsigned char BYTE;
typedef unsigned int DWORD;
typedef unsigned short WORD;
typedef unsigned int BOOL;

# if 0
  typedef struct MO5_save_t {

    SDL_Surface    *surface;
    char            used;
    char            thumb;
    ScePspDateTime  date;

  } MO5_save_t;
# endif

  typedef struct MO5_t {
 
# if 0
    MO5_save_t mo5_save_state[MO5_MAX_SAVE_STATE];
# endif
    char mo5_save_name[MAX_PATH];
    char mo5_home_dir[MAX_PATH];
    int  psp_screenshot_id;
    int  psp_cpu_clock;
    int  psp_reverse_analog;
    int  psp_display_lr;
    int  mo5_view_fps;
    int  mo5_current_fps;
    int  mo5_snd_enable;
    int  mo5_render_mode;
    int  mo5_vsync;
    int  psp_active_joystick;
    int  psp_skip_max_frame;
    int  psp_skip_cur_frame;
    int  mo5_speed_limiter;
    int  mo5_auto_fire;
    int  mo5_auto_fire_pressed;
    int  mo5_auto_fire_period;

  } MO5_t;

  extern MO5_t MO5;


//END_LUDO:
  extern void mo5_default_settings(void);
  extern int mo5_save_settings(void);
  extern int mo5_load_settings();
  extern int mo5_load_file_settings(char *FileName);

  extern void mo5_update_save_name(char *Name);
  extern void reset_save_name();
  extern void mo5_kbd_load(void);
  extern int mo5_kbd_save(void);
  extern void emulator_reset(void);
  extern int mo5_load_rom(char *FileName, int zip_format);
  extern int mo5_load_k7(char *FileName);
  extern int mo5_load_fd(char *FileName);
  extern int mo5_load_state(char *FileName);
  extern int mo5_snapshot_save_slot(int save_id);
  extern int mo5_snapshot_load_slot(int load_id);
  extern int mo5_snapshot_del_slot(int save_id);

  extern int psp_screenshot_mode;

#ifdef __cplusplus
}
#endif

#endif
